package com.ekexiu.portal.article.file;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;
@DAO
public interface ArticleFileDao {
	@Insert
	@Batch
	 int[] insert(Connection con,ArticleFile files[])throws SQLException;
	
	@OrderBy("ORDER BY SEQ ASC")
	@SelectList
	List<ArticleFile> query(Connection con,String id)throws SQLException;
	@SelectOne
	@Nullable
	ArticleFile queryByurl(Connection con,String url)throws SQLException;
	
	
	@DeleteWith
	@From(ArticleFile.class)
	int delete(Connection con,String id)throws SQLException;
}
