package com.ekexiu.portal.dao;

import com.ekexiu.portal.po.DiscoverBanner;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/8/25.
 */
@DAO
public interface DiscoverBannerDao {

    @UpdateWith
    @From(DiscoverBanner.class)
    @SetSentence("clicks = clicks + 1")
    int incClicks(Connection con, long id) throws SQLException;
}
