package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;

import com.ekexiu.portal.po.OrgResStaff;

@DAO
public abstract class OrgResStaffDao {
	@Insert
	public abstract int insert(Connection con, OrgResStaff orgResStaff) throws SQLException;
	
	@SelectList
	public abstract List<OrgResStaff> query(Connection con, String resourceId) throws SQLException;
	
	@DeleteWith
	@From(OrgResStaff.class)
	public abstract int delete(Connection con, String resourceId) throws SQLException;
	
	@DeleteWith
	@From(OrgResStaff.class)
	public abstract int deletePro(Connection con, String professorId) throws SQLException;
}
