package com.ekexiu.portal.platform;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.CreateTimeSupported;

/**
 * 对接的合作机构
 * 
 * @author Saga
 *
 */
@PrimaryKey({ "pid", "oid" })
@Table
public class ButtedOrg implements CreateTimeSupported {
	/**
	 * 平台ID
	 */
	private String pid;
	/**
	 * 对接的合作机构ID(企业ID)
	 */
	private String oid;

	private String createTime;

	@Column(DE.text_de)
	public String getPid() {
		return pid;
	}

	public void setPid(String pid) {
		this.pid = pid;
	}

	@Column(DE.text_de)
	public String getOid() {
		return oid;
	}

	public void setOid(String oid) {
		this.oid = oid;
	}

	public String getCreateTime() {
		return createTime;
	}

	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}

}
