package com.ekexiu.portal.service;

import com.ekexiu.portal.dao.ArticleDao;
import com.ekexiu.portal.dao.HonorDao;
import com.ekexiu.portal.dao.ImageDao;
import com.ekexiu.portal.dao.OrgDao;
import com.ekexiu.portal.dao.OrgResStaffDao;
import com.ekexiu.portal.dao.PaperAuthorDao;
import com.ekexiu.portal.dao.PaperDao;
import com.ekexiu.portal.dao.PartTimeJobDao;
import com.ekexiu.portal.dao.PatentAuthorDao;
import com.ekexiu.portal.dao.PatentDao;
import com.ekexiu.portal.dao.ProfessorDao;
import com.ekexiu.portal.dao.ProfessorEduBgDao;
import com.ekexiu.portal.dao.ProjectDao;
import com.ekexiu.portal.dao.ResearchAreaDao;
import com.ekexiu.portal.dao.ResearchAreaLogDao;
import com.ekexiu.portal.dao.ResourceDao;
import com.ekexiu.portal.dao.UserDao;
import com.ekexiu.portal.dao.WatchDao;
import com.ekexiu.portal.org.OrgLinkManDao;
import com.ekexiu.portal.po.Organization;
import com.ekexiu.portal.po.Professor;
import com.ekexiu.portal.po.Resource;
import com.ekexiu.portal.po.User;
import com.ekexiu.portal.pojo.EditProfessor;
import com.ekexiu.portal.pojo.EditResearchAreaLog;
import com.ekexiu.portal.pojo.ProfessorInfo;
import com.ekexiu.portal.pojo.SortedPro;
import com.ekexiu.portal.pojo.UserInfo;
import com.ekexiu.portal.product.ProductDao;
import com.ekexiu.portal.util.Calculate;
import com.ekexiu.portal.ware.WareDao;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Delete;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestBody;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;
import org.jfw.util.jdbc.JdbcUtil;
import org.jfw.util.jdbc.PreparedStatementConfig;

import java.io.IOException;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Path("/professor")
public class ProfessorService {
	@Autowrie
	private GrowthLogService growthLogService;
	@Autowrie
	private GrowthRuleService rule;
	@Autowrie
	private ArticleDao articleDao;
	@Autowrie
	private ImageDao imageDao;
	@Autowrie
	private UserDao userDao;
	@Autowrie
	private WatchDao watchDao;
	@Autowrie
	private Calculate calculate;
	@Autowrie
	private ResourceDao resourceDao;
	@Autowrie
	private ImageService imageService;
	@Autowrie
	private OrgService orgService;
	@Autowrie
	private PaperDao paperDao;
	@Autowrie
	private OrgDao orgDao;
	@Autowrie
	private ProfessorDao professorDao;
	@Autowrie
	private ResearchAreaLogDao researchAreaLogDao;
	@Autowrie
	private ResearchAreaDao researchAreaDao;
	@Autowrie
	private ProfessorEduBgDao professorEduBgDao;
	@Autowrie
	private PartTimeJobDao partTimeJobDao;
	@Autowrie
	private PatentDao patentDao;
	@Autowrie
	private HonorDao honorDao;
	@Autowrie
	private ProjectDao projectDao;
	@Autowrie
	private OrgResStaffDao orgResStaffDao;
	@Autowrie
	private PatentAuthorDao patentAuthorDao;
	@Autowrie
	private PaperAuthorDao paperAuthorDao;

	@Autowrie
	private KeyWordService keyWordService;

	@Autowrie
	private WareDao wareDao;

	@Autowrie
	private OrgLinkManDao orgLinkManDao;

	@Autowrie
	private ProductDao productDao;

//	@Autowrie
//	private DemandDao demandDao;
//
//	public DemandDao getDemandDao() {
//		return demandDao;
//	}
//
//	public void setDemandDao(DemandDao demandDao) {
//		this.demandDao = demandDao;
//	}

	public PatentAuthorDao getPatentAuthorDao() {
		return patentAuthorDao;
	}

	public void setPatentAuthorDao(PatentAuthorDao patentAuthorDao) {
		this.patentAuthorDao = patentAuthorDao;
	}

	public PaperAuthorDao getPaperAuthorDao() {
		return paperAuthorDao;
	}

	public void setPaperAuthorDao(PaperAuthorDao paperAuthorDao) {
		this.paperAuthorDao = paperAuthorDao;
	}

	public KeyWordService getKeyWordService() {
		return keyWordService;
	}

	public void setKeyWordService(KeyWordService keyWordService) {
		this.keyWordService = keyWordService;
	}

	public GrowthLogService getGrowthLogService() {
		return growthLogService;
	}

	public void setGrowthLogService(GrowthLogService growthLogService) {
		this.growthLogService = growthLogService;
	}

	public GrowthRuleService getRule() {
		return rule;
	}

	public void setRule(GrowthRuleService rule) {
		this.rule = rule;
	}

	public ArticleDao getArticleDao() {
		return articleDao;
	}

	public void setArticleDao(ArticleDao articleDao) {
		this.articleDao = articleDao;
	}

	public UserDao getUserDao() {
		return userDao;
	}

	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}

	public WatchDao getWatchDao() {
		return watchDao;
	}

	public void setWatchDao(WatchDao watchDao) {
		this.watchDao = watchDao;
	}

	public Calculate getCalculate() {
		return calculate;
	}

	public void setCalculate(Calculate calculate) {
		this.calculate = calculate;
	}

	public ResourceDao getResourceDao() {
		return resourceDao;
	}

	public void setResourceDao(ResourceDao resourceDao) {
		this.resourceDao = resourceDao;
	}

	public ImageService getImageService() {
		return imageService;
	}

	public void setImageService(ImageService imageService) {
		this.imageService = imageService;
	}

	public OrgService getOrgService() {
		return orgService;
	}

	public void setOrgService(OrgService orgService) {
		this.orgService = orgService;
	}

	public ProjectDao getProjectDao() {
		return projectDao;
	}

	public void setProjectDao(ProjectDao projectDao) {
		this.projectDao = projectDao;
	}

	public HonorDao getHonorDao() {
		return honorDao;
	}

	public void setHonorDao(HonorDao honorDao) {
		this.honorDao = honorDao;
	}

	public PatentDao getPatentDao() {
		return patentDao;
	}

	public void setPatentDao(PatentDao patentDao) {
		this.patentDao = patentDao;
	}

	public PartTimeJobDao getPartTimeJobDao() {
		return partTimeJobDao;
	}

	public void setPartTimeJobDao(PartTimeJobDao partTimeJobDao) {
		this.partTimeJobDao = partTimeJobDao;
	}

	public PaperDao getPaperDao() {
		return paperDao;
	}

	public void setPaperDao(PaperDao paperDao) {
		this.paperDao = paperDao;
	}

	public ProfessorEduBgDao getProfessorEduBgDao() {
		return professorEduBgDao;
	}

	public void setProfessorEduBgDao(ProfessorEduBgDao professorEduBgDao) {
		this.professorEduBgDao = professorEduBgDao;
	}

	public ResearchAreaLogDao getResearchAreaLogDao() {
		return researchAreaLogDao;
	}

	public void setResearchAreaLogDao(ResearchAreaLogDao researchAreaLogDao) {
		this.researchAreaLogDao = researchAreaLogDao;
	}

	public ResearchAreaDao getResearchAreaDao() {
		return researchAreaDao;
	}

	public void setResearchAreaDao(ResearchAreaDao researchAreaDao) {
		this.researchAreaDao = researchAreaDao;
	}

	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	public OrgDao getOrgDao() {
		return orgDao;
	}

	public void setOrgDao(OrgDao orgDao) {
		this.orgDao = orgDao;
	}

	public ImageDao getImageDao() {
		return imageDao;
	}

	public void setImageDao(ImageDao imageDao) {
		this.imageDao = imageDao;
	}

	public OrgResStaffDao getOrgResStaffDao() {
		return orgResStaffDao;
	}

	public void setOrgResStaffDao(OrgResStaffDao orgResStaffDao) {
		this.orgResStaffDao = orgResStaffDao;
	}

	public WareDao getWareDao() {
		return wareDao;
	}

	public void setWareDao(WareDao wareDao) {
		this.wareDao = wareDao;
	}

	public OrgLinkManDao getOrgLinkManDao() {
		return orgLinkManDao;
	}

	public void setOrgLinkManDao(OrgLinkManDao orgLinkManDao) {
		this.orgLinkManDao = orgLinkManDao;
	}

	public ProductDao getProductDao() {
		return productDao;
	}

	public void setProductDao(ProductDao productDao) {
		this.productDao = productDao;
	}

	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, Professor professor, @Nullable String orgName) throws SQLException, IOException {
		if (professor.getId() == null) {
			professor.setId(StringUtil.buildUUID());
		}
		if (professor.getOrgId() == null && orgName != null) {
			if (null != this.orgDao.queryByName(con, orgName)) {
				professor.setOrgId(this.orgDao.queryByName(con, orgName));
			} else {
				professor.setOrgId(this.orgService.createOrganization(con, orgName));
			}
		}
		if (professor.getOrgAuth() == null) {
			professor.setOrgAuth("0");
		}
		User user = this.userDao.query(con, professor.getId());
		if (user != null) {
			int value = 0;
			if (user.getMobilePhone() != null && user.getMobilePhone().trim().length() == 11) {
				professor.setPhone(user.getMobilePhone());
				value = value + this.rule.getBindMobile();
				this.growthLogService.bindMobile(con, professor.getId());
			}
			if (user.getEmail() != null && !"".equals(user.getEmail())) {
				professor.setEmail(user.getEmail());
				value = value + this.rule.getBindEmail();
				this.growthLogService.bindEmail(con, professor.getId());
			}
			professor.setScoreValue(value);
			professor.setGrowthValue(value);
		} else {
			professor.setScoreValue(0);
			professor.setGrowthValue(0);
		}
		this.professorDao.insert(con, professor);
		return professor.getId();
	}

	@Post
	@Path("/org")
	public boolean updateOrgid(@JdbcConn(true) Connection con,final String id, String name) throws SQLException, IOException {
		Professor p = this.professorDao.query(con, id);
		if (p != null) {
			String oid = this.orgService.createOrganization(con, name);
			String old = p.getOrganization().getId();
			if (!oid.equals(old)) {
				this.professorDao.updateOrg(con, oid, id);
				if (old != null) {
					this.professorDao.updateOrgAuth(con, id, "0");
//					this.demandDao.closeByCreator(con, id, id);
					this.orgResStaffDao.deletePro(con, id);
					this.orgLinkManDao.deleteByPid(con, id);
					this.wareDao.deletePro(con, id);
					this.productDao.deletePro(con, id);
				}
				return true;
			}
		}
		return false;
	}

	@Put
	@Path
	public void update(@JdbcConn(true) Connection con,final @RequestBody EditProfessor professor) throws SQLException, IOException {
		if (professor.getOrgName() != null)
			if (null != this.orgDao.queryByName(con, professor.getOrgName())) {
				professor.setOrgId(this.orgDao.queryByName(con, professor.getOrgName()));
			} else {
				professor.setOrgId(this.orgService.createOrganization(con, professor.getOrgName()));
			}
		Professor op = this.professorDao.query(con, professor.getId());

		String old_oid = op.getOrganization().getId();
		String new_oid = professor.getOrgId();

		if (this.professorDao.update(con, professor) > 0) {
			if (!professor.getName().equals(op.getName())) {
				this.paperAuthorDao.cAss(con, professor.getId());
				this.patentAuthorDao.cAss(con, professor.getId());
			}
			if (old_oid != null && (!old_oid.equals(new_oid))) {
				this.professorDao.updateOrgAuth(con, op.getId(), "0");
//				this.demandDao.closeByCreator(con, op.getId(), op.getId());
				this.orgResStaffDao.deletePro(con, op.getId());
				this.orgLinkManDao.deleteByPid(con, op.getId());
				this.wareDao.deletePro(con, op.getId());
				this.productDao.deletePro(con, op.getId());
			}
		}
		;
	}

	@Post
	@Path("/updatePro")
	public void updatePro(@JdbcConn(true) Connection con, EditProfessor professor) throws SQLException, IOException {
		if (professor.getOrgName() != null)
			if (null != this.orgDao.queryByName(con, professor.getOrgName())) {
				professor.setOrgId(this.orgDao.queryByName(con, professor.getOrgName()));
			} else {
				professor.setOrgId(this.orgService.createOrganization(con, professor.getOrgName()));
			}
		Professor op = this.professorDao.query(con, professor.getId());

		String old_oid = op.getOrganization().getId();
		String new_oid = professor.getOrgId();
		if (this.professorDao.update(con, professor) > 0) {
			if (!professor.getName().equals(op.getName())) {
				this.paperAuthorDao.cAss(con, professor.getId());
				this.patentAuthorDao.cAss(con, professor.getId());
			}
			if (old_oid != null && (!old_oid.equals(new_oid))) {
				this.professorDao.updateOrgAuth(con, op.getId(), "0");
//				this.demandDao.closeByCreator(con, op.getId(), op.getId());
				this.orgResStaffDao.deletePro(con, op.getId());
				this.orgLinkManDao.deleteByPid(con, op.getId());
				this.wareDao.deletePro(con, op.getId());
				this.productDao.deletePro(con, op.getId());
			}
		}
		;
	}

	@Get
	@Path("/queryInvite")
	public List<EditProfessor> queryInvite(@JdbcConn Connection con, String id) throws SQLException {
		List<EditProfessor> professors = this.professorDao.queryInvite(con, id);
		for (EditProfessor professor : professors) {
			professor.setHasHeadImage(this.imageService.hasProfessorImage(professor.getId()));
			professor.setResearchAreas(this.researchAreaDao.query(con, professor.getId()));
			professor.setResources(this.resourceDao.queryList(con, professor.getId()));
		}
		return professors;
	}

	@Get
	@Path("/auth")
	public Professor queryAuth(@JdbcConn Connection con, String id) throws SQLException {
		return this.professorDao.queryAuth(con, id);
	}

	@Get
	@Path("/baseInfo/{id}")
	public EditProfessor queryBaseInfo(@JdbcConn Connection con, @PathVar String id) throws SQLException {
		EditProfessor professor = this.professorDao.queryBaseInfo(con, id);
		if (null != professor) {
			professor.setHasHeadImage(this.imageService.hasProfessorImage(id));
			hiddenPrivacyInfo(professor);
		}
		return professor;
	}

	@Get
	@Path("/qaByName")
	public List<EditProfessor> queryByName(@JdbcConn Connection con, @Nullable String name, @DefaultValue("3") int total) throws SQLException {
		if (name != null) {
			name = "%" + name + "%";
		}
		List<EditProfessor> professors = this.professorDao.queryByName(con, name, total);
		for (EditProfessor professor : professors) {
			professor.setHasHeadImage(this.imageService.hasProfessorImage(professor.getId()));
			hiddenPrivacyInfo(professor);
		}
		return professors;
	}

	@Get
	@Path("/editBaseInfo/{id}")
	public EditProfessor queryEditBaseInfo(@JdbcConn Connection con, @PathVar String id) throws SQLException {
		EditProfessor professor = this.professorDao.queryEditBaseInfo(con, id);
		if (null != professor) {
			professor.setHasHeadImage(this.imageService.hasProfessorImage(id));
		}
		return professor;
	}

	@Get
	@Path("/{id}")
	public Professor query(@JdbcConn Connection con, @PathVar String id) throws SQLException {
		Professor ret = this.professorDao.query(con, id);
		if (null != ret) {
			hiddenPrivacyInfo(ret);
		}
		return ret;

	}

	@Get
	@Path("/qa")
	public List<Professor> queryAll(@JdbcConn Connection con) throws SQLException {
		return hiddenPrivacyInfo(this.professorDao.query(con));
	}

	@Get
	@Path("/pqOrgAuth")
	public PageQueryResult<EditProfessor> queryPageOrgAuth(@JdbcConn Connection con, String orgId, @Nullable String orgAuth, @DefaultValue("10") int pageSize,
			@DefaultValue("1") int pageNo) throws SQLException {
		PageQueryResult<EditProfessor> queryResult = this.professorDao.queryPage(con, orgId, orgAuth, pageSize, pageNo);
		List<EditProfessor> professors = queryResult.getData();
		if (!professors.isEmpty()) {
			for (EditProfessor professor : professors) {
				professor.setHasHeadImage(this.imageService.hasProfessorImage(professor.getId()));
				professor.setResearchAreas(this.researchAreaDao.query(con, professor.getId()));
			}
			hiddenPrivacyInfo(professors);
			queryResult.setData(professors);
		}
		return queryResult;
	}

	@Get
	@Path("/qaOrgAuth")
	public List<EditProfessor> queryOrgAuth(@JdbcConn Connection con, String orgId, @Nullable String orgAuth) throws SQLException {
		List<EditProfessor> professors = this.professorDao.queryByOrg(con, orgId, orgAuth);
		for (EditProfessor professor : professors) {
			professor.setHasHeadImage(this.imageService.hasProfessorImage(professor.getId()));
			professor.setResearchAreas(this.researchAreaDao.query(con, professor.getId()));
		}
		return hiddenPrivacyInfo(professors);
	}

	/**
	 * 企业联系人
	 *
	 * @param con
	 * @param orgId  企业ID
	 * @param ids  企业默认联系人
	 * @param lid limit查询最后一条的id 首次不传
	 * @param rows limit查询最后一条的最大返回条数
	 * @return
	 * @throws SQLException
	 */
	@Get
	@Path("/orgAuth/nonDef")
	public List<EditProfessor> orgAuth(@JdbcConn Connection con,String[] ids,String orgId,String lid,int rows)throws SQLException {
		List<EditProfessor> professors = this.professorDao.orgAuth(con,orgId,ids,lid,rows);
		for (EditProfessor professor : professors) {
			professor.setHasHeadImage(this.imageService.hasProfessorImage(professor.getId()));
			professor.setResearchAreas(this.researchAreaDao.query(con, professor.getId()));
		}
		return hiddenPrivacyInfo(professors);
	}

	@Get
	@Path("/pqOrgAuth")
	public PageQueryResult<EditProfessor> pqOrgAuth(@JdbcConn Connection con,String orgId,@Nullable String orgAuth,int pageSize,int pageNo)throws SQLException {
		PageQueryResult<EditProfessor> professors = this.professorDao.pqOrgAuth(con, orgId,orgAuth, pageSize, pageNo);
		for (EditProfessor professor : professors.getData()) {
			professor.setHasHeadImage(this.imageService.hasProfessorImage(professor.getId()));
			professor.setResearchAreas(this.researchAreaDao.query(con, professor.getId()));
			hiddenPrivacyInfo(professor);
		}
		return professors;
	}

	public void updateStarAvg(Connection con) throws SQLException {
		try {
			List<Professor> professors = this.professorDao.queryStar(con);
			BigDecimal bigStar = this.professorDao.queryBigStar(con);
			BigDecimal smallStar = this.professorDao.querySmallStar(con);
			BigDecimal bigConsult = this.professorDao.queryBigConsult(con);
			BigDecimal smallConsult = this.professorDao.querySmallConsult(con);
			for (Professor professor : professors) {
				BigDecimal star = professor.getStarLevel();
				BigDecimal consult = new BigDecimal(professor.getConsultCount());
				BigDecimal avgStar = this.calculate.calcAvgStar(bigStar, smallStar, bigConsult, smallConsult, star, consult);
				this.professorDao.updateStarAvg(con, professor.getId(), avgStar);
			}
		} catch (Exception e) {
			con.rollback();
			e.printStackTrace();
		}
	}

	public void updateScorePercent(Connection con) throws SQLException {
		List<Professor> professors = this.professorDao.queryList(con);
		int count = this.professorDao.queryCount(con);
		try {
			for (Professor professor : professors) {
				int lessThan = this.professorDao.queryCountLessThan(con, professor.getScoreValue());
				double value = 0;
				if (count != 0) {
					value = (double) lessThan / (double) count;
				}
				DecimalFormat df = new DecimalFormat("#%");
				this.professorDao.updateScorePercent(con, professor.getId(), df.format(value));
			}
		} catch (Exception e) {
			con.rollback();
			e.printStackTrace();
		}
	}

	@Get
	@Path("/pqHot")
	public PageQueryResult<EditProfessor> queryHot(@JdbcConn Connection con, @DefaultValue("8") int pageSize, @DefaultValue("1") int pageNo)
			throws SQLException {
		PageQueryResult<EditProfessor> queryResult = this.professorDao.queryHot(con, pageSize, pageNo);
		List<EditProfessor> professors = queryResult.getData();
		if (!professors.isEmpty()) {
			for (EditProfessor editProfessor : professors) {
				editProfessor.setHasHeadImage(this.imageService.hasProfessorImage(editProfessor.getId()));
				editProfessor.setResearchAreas(this.researchAreaDao.query(con, editProfessor.getId()));
				editProfessor.setResources(this.resourceDao.queryList(con, editProfessor.getId()));
				editProfessor.setPhone(null);
				editProfessor.setEmail(null);
			}
		}
		return queryResult;
	}

	@Get
	@Path("/pqAPP")
	public PageQueryResult<EditProfessor> queryAPP(@JdbcConn Connection con, @Nullable String key, @Nullable String subject, @Nullable String industry,
			@Nullable String province, @Nullable String address, @DefaultValue("1") Integer authType, @DefaultValue("10") int pageSize,
			@DefaultValue("1") int pageNo) throws SQLException {
		if (key != null) {
			key = "%" + key + "%";
		}
		if (subject != null) {
			subject = "%" + subject + "%";
		}
		if (null != industry) {
			industry = "%" + industry + "%";
		}
		if (null != province) {
			province = "%" + province + "%";
		}
		if (null != address) {
			address = "%" + address + "%";
		}
		PageQueryResult<EditProfessor> queryResult = this.professorDao.queryAPP(con, key, subject, industry, province, address, authType, pageSize, pageNo);
		List<EditProfessor> editProfessors = queryResult.getData();
		if (!editProfessors.isEmpty()) {
			for (EditProfessor editProfessor : editProfessors) {
				editProfessor.setHasHeadImage(this.imageService.hasProfessorImage(editProfessor.getId()));
				editProfessor.setResearchAreas(this.researchAreaDao.query(con, editProfessor.getId()));
				editProfessor.setResources(this.resourceDao.queryList(con, editProfessor.getId()));
			}
			queryResult.setData(editProfessors);
			hiddenPrivacyInfo(editProfessors);
		}
		return queryResult;
	}

	@Post
	@Path("/sortFirst")
	public void updateSortFirst(@JdbcConn(true) Connection con, String id, Integer sortFirst) throws SQLException {
		this.professorDao.updateSortFirst(con, id, sortFirst);
	}

	@Post
	@Path("/authentication")
	public void updateAuthentication(@JdbcConn(true) Connection con, String id, Integer authentication, Integer authType, Integer authStatus)
			throws SQLException {
		this.professorDao.updateAuthentication(con, id, authentication, authType, authStatus);
	}

	@Post
	@Path("/authType")
	public void updateAuthType(@JdbcConn(true) Connection con, String id, Integer authType) throws SQLException {
		this.professorDao.updateAuthType(con, id, authType);
	}

	@Post
	@Path("/authen")
	public void updateAuthen(@JdbcConn(true) Connection con, String id, Integer authentication) throws SQLException {
		this.professorDao.updateAuthentication(con, id, authentication);
	}

	@Post
	@Path("/authStatus")
	public void updateAuthStatus(@JdbcConn(true) Connection con, String id, Integer authStatus) throws SQLException {
		this.professorDao.updateAuthStatus(con, id, authStatus);
	}

	@Post
	@Path("/passOrgAuth")
	public void passOrgAuth(@JdbcConn(true) Connection con, String id) throws SQLException {
		this.professorDao.updateOrgAuth(con, id, "1");
		// 通过企业认证给用户增加积分
		this.growthLogService.authOrg(con, id);
	}
	
	
	@Post
	@Path("/joinAndPassOrgAuth")
	public void passOrgAuth(@JdbcConn(true) Connection con, String pid,String oid) throws SQLException {
		this.orgLinkManDao.deleteByPid(con, pid);
		this.wareDao.deleteWarePro(con, pid);
		this.orgResStaffDao.deletePro(con, pid);
		this.productDao.deleteProductPro(con, pid);
		this.professorDao.joinAndPassOrgAuth(con, pid, oid, "1");
	}

	@Post
	@Path("/removeOrgAuth")
	public void removeOrgAuth(@JdbcConn(true) Connection con, String id) throws SQLException {
		this.professorDao.updateOrgAuth(con, id, "0");
		this.wareDao.deletePro(con, id);
		this.productDao.deletePro(con, id);
		this.orgLinkManDao.deleteByPid(con, id);
		this.orgResStaffDao.deletePro(con, id);
	}

	@Post
	@Path("/starLevel")
	public void updateStarLevel(@JdbcConn(true) Connection con, String id, BigDecimal starLevel) throws SQLException {
		this.professorDao.updateStarLevel(con, id, starLevel);
	}

	@Post
	@Path("/subject")
	public void updateSubject(@JdbcConn(true) Connection con, String id, @Nullable String subject) throws SQLException {
		this.professorDao.updateSubject(con, id, subject);
		Professor p = this.professorDao.query(con, id);
		// String subject = p.getSubject();
		if (subject == null)
			subject = "";
		String industry = p.getIndustry();
		if (industry == null)
			industry = "";
		this.keyWordService.refreshProfessor(con, id, KeyWordService.splitKeyWord(subject + "," + industry));
	}

	@Post
	@Path("/industry")
	public void updateIndustry(@JdbcConn(true) Connection con, String id, @Nullable String industry) throws SQLException {
		this.professorDao.updateIndustry(con, id, industry);
		Professor p = this.professorDao.query(con, id);
		String subject = p.getSubject();
		if (subject == null)
			subject = "";
		if (industry == null)
			industry = "";
		this.keyWordService.refreshProfessor(con, id, KeyWordService.splitKeyWord(subject + "," + industry));
	}

	@Post
	@Path("/address")
	public void updateAddress(@JdbcConn(true) Connection con, String id, @Nullable String province, @Nullable String address) throws SQLException {
		this.professorDao.updateProvince(con, id, province);
		this.professorDao.updateAddress(con, id, address);
	}

	@Post
	@Path("/descp")
	public void updateDescp(@JdbcConn(true) Connection con, String id, @Nullable String descp) throws SQLException {
		this.professorDao.updateDescp(con, id, descp);
	}

	@Delete
	@Path("/{id}")
	public void delete(@JdbcConn(true) Connection con, @PathVar String id) throws SQLException {
		this.researchAreaLogDao.delete(con, id);
		this.researchAreaDao.delete(con, id);
		this.professorEduBgDao.delete(con, id);
		this.partTimeJobDao.delete(con, id);
		this.paperDao.delete(con, id);
		this.professorDao.delete(con, id);
		this.patentDao.delete(con, id);
		this.honorDao.delete(con, id);
		this.projectDao.delete(con, id);
		this.watchDao.deletePro(con, id);
		this.watchDao.deleteWatch(con, id);
		this.resourceDao.deletePro(con, id);
		this.articleDao.deletePro(con, id);
		this.keyWordService.refreshProfessor(con, id, null);
	}

	@Get
	@Path("/pqBaseInfo")
	public PageQueryResult<EditProfessor> queryEditBaseInfo(@JdbcConn(false) Connection con, @Nullable String key, @Nullable String subject,
			@Nullable String industry, @Nullable String address, @Nullable Integer authType, @DefaultValue("10") int pageSize, @DefaultValue("1") int pageNo)
			throws SQLException {
		if (key != null) {
			key = "%" + key + "%";
		}
		if (subject != null) {
			subject = "%" + subject + "%";
		}
		if (null != industry) {
			industry = "%" + industry + "%";
		}
		if (null != address) {
			address = "%" + address + "%";
		}
		PageQueryResult<EditProfessor> queryResult = this.professorDao.queryEditBaseInfo(con, key, subject, industry, address, authType, pageSize, pageNo);
		List<EditProfessor> editProfessors = queryResult.getData();
		if (!editProfessors.isEmpty()) {
			for (EditProfessor editProfessor : editProfessors) {
				editProfessor.setHasHeadImage(this.imageService.hasProfessorImage(editProfessor.getId()));
				editProfessor.setResearchAreas(this.researchAreaDao.query(con, editProfessor.getId()));
			}
			hiddenPrivacyInfo(editProfessors);
			queryResult.setData(editProfessors);
		}
		return queryResult;
	}

	@Get
	@Path("/index/search")
	public List<SortedPro> searchPro(@JdbcConn(false) Connection con, @Nullable String key, @Nullable String subject,
									 @Nullable String industry, @Nullable String address, @Nullable Integer authType, @DefaultValue("99999") int sortFirst, @DefaultValue("\"Z\"")String id, @DefaultValue("0")double starLevel, @DefaultValue("10000000") int rows)
			throws SQLException {
		if (key != null) {
			key = "%" + key + "%";
		}
		if (subject != null) {
			subject = "%" + subject + "%";
		}
		if (null != industry) {
			industry = "%" + industry + "%";
		}
		if (null != address) {
			address = "%" + address + "%";
		}
		String sortDesc = "000000"+ sortFirst;
		String a =  "0000" + (int)(starLevel*100);
		sortDesc = sortDesc.substring(sortDesc.length()-5)+a.substring(a.length()-4)+id;
		List<SortedPro> queryResult = this.professorDao.indexSearch(con,sortDesc, key, subject, industry, address, authType,rows );
		if (!queryResult.isEmpty()) {
			for (SortedPro editProfessor : queryResult) {
				editProfessor.setHasHeadImage(this.imageService.hasProfessorImage(editProfessor.getId()));
				editProfessor.setResearchAreas(this.researchAreaDao.query(con, editProfessor.getId()));
			}
			hiddenPrivacyInfo(queryResult);
		}
		return queryResult;
	}

	@Get
	@Path("/pqUserInfo")
	public PageQueryResult<UserInfo> queryUserInfo(@JdbcConn(false) Connection con, @Nullable String key, @Nullable String address, @Nullable String orgName,
			@Nullable Integer activeState, @Nullable Integer authType, @DefaultValue("20") int pageSize, @DefaultValue("1") int pageNo) throws SQLException {
		if (key != null) {
			key = "%" + key + "%";
		}
		if (null != address) {
			address = "%" + address + "%";
		}
		if (orgName != null) {
			orgName = "%" + orgName + "%";
		}
		return this.professorDao.queryUserInfo(con, key, address, authType, orgName, activeState, pageSize, pageNo);
	}

	@Get
	@Path("/pq")
	public PageQueryResult<Professor> query(@JdbcConn(false) Connection con, @Nullable String key, @Nullable String subject, @Nullable String industry,
			@Nullable String address, @DefaultValue("10") int pageSize, @DefaultValue("1") int pageNo) throws SQLException {
		// System.out.println("key==["+(key==null?"":key)+"]");
		// System.out.println("subject==["+(subject==null?"":subject)+"]");
		// System.out.println("industry==["+(industry==null?"":industry)+"]");
		if (key != null)
			key = "%" + key + "%";
		if (subject != null)
			subject = "%" + subject + "%";
		if (null != industry)
			industry = "%" + industry + "%";
		if (null != address)
			address = "%" + address + "%";
		return this.professorDao.query(con, key, subject, industry, address, pageSize, pageNo);
	}

	@Get
	@Path("/agree/sum")
	public long agreeSum(@JdbcConn Connection con, final String id) throws SQLException {
		return JdbcUtil.queryLong(con,
				" select SUM(agree) from (SELECT article_agree agree FROM ARTICLE WHERE STATUS ='1' AND owner_id =? AND ARTICLE_TYPE = '1' UNION ALL SELECT AGREE FROM ANSWER WHERE STATE='1' AND UID =? ) t",
				new PreparedStatementConfig() {
					@Override
					public void config(PreparedStatement ps) throws SQLException {
						ps.setString(1, id);
						ps.setString(2, id);

					}
				}, 0);

	}

	@Get
	@Path("/editInfo/{id}")
	public ProfessorInfo editInfo(@JdbcConn(false) Connection con, @PathVar String id) throws SQLException {
		ProfessorInfo info = this.professorDao.queryInfo(con, id);
		if (info != null) {
			if (info.getOrgId() != null) {
				info.setOrgName(this.orgDao.query(con, info.getOrgId()).getName());
			}
			info.setHasHeadImage(this.imageService.hasProfessorImage(id));
			info.setEdus(this.professorEduBgDao.query(con, id));
			info.setHonors(this.honorDao.query(con, id));
			info.setJobs(this.partTimeJobDao.query(con, id));
			info.setPapers(this.paperDao.query(con, id));
			info.setPatents(this.patentDao.query(con, id));
			info.setProjects(this.projectDao.query(con, id));
			List<EditResearchAreaLog> logs = this.researchAreaLogDao.query(con, id);
			if (!logs.isEmpty()) {
				for (EditResearchAreaLog log : logs) {
					log.setHasHeadImage(this.imageService.hasProfessorImage(log.getOpreteProfessorId()));
				}
			}
			info.setEditResearchAreaLogs(logs);
			info.setResearchAreas(this.researchAreaDao.query(con, id));
			List<Resource> resources = this.resourceDao.queryPro(con, id);
			if (!resources.isEmpty()) {
				for (Resource resource : resources) {
					resource.setImages(this.imageDao.queryRes(con, resource.getResourceId()));
				}
			}
			info.setResources(resources);
		}
		return info;

	}

	@Get
	@Path("/info/{id}")
	public ProfessorInfo qinfo(@JdbcConn(false) Connection con, @PathVar String id) throws SQLException {
		ProfessorInfo qi = this.editInfo(con, id);
		if (qi != null) {
			qi.setPhone(null);
			qi.setEmail(null);
		}
		return qi;
	}

	@Get
	@Path("/byShareId")
	public Professor query(@JdbcConn Connection con, long id) throws SQLException {
		return hiddenPrivacyInfo(this.professorDao.query(con, id));
	}

	/**
	 * 增加用户浏览量
	 * 
	 * @param con
	 * @param id
	 * @throws SQLException
	 */
	@Post
	@Path("/incPageViews")
	public void incPageViews(@JdbcConn(true) Connection con, String id) throws SQLException {
		this.professorDao.incPageViews(con, id);
	}

	@Get
	@Path("/ralateProfessors")
	public List<Professor> ralateArticles(@JdbcConn Connection con, String professorId, @DefaultValue("5") int rows) throws SQLException {
		String[] ids = this.professorDao.queryProfessorIdWithSameKeyWord(con, professorId, rows);
		if (ids != null) {
			List<Professor> ret = this.professorDao.query(con, ids);

			return hiddenPrivacyInfo(ret);
		}
		return Collections.<Professor> emptyList();
	}

	@Get
	@Path("/coadjutant")
	public List<Map<String, Object>> queryCoadjutant(@JdbcConn Connection con, String id, @DefaultValue("5") int rows) throws SQLException {
		PreparedStatement ps = con.prepareStatement("SELECT professor_id,SUM (patent_count) patent_count,	SUM (paper_count) paper_count, "
				+ "SUM (tc) tc FROM ((SELECT professor_id,COUNT (1) patent_count,0 paper_count,COUNT (1) tc FROM patent_author WHERE patent_id IN ("
				+ "SELECT DISTINCT patent_id FROM patent_author WHERE professor_id = ? ) AND professor_id <> ? AND professor_id <> '################################' "
				+ "GROUP BY professor_id) UNION ALL (SELECT professor_id,0 patent_count,COUNT (1) paper_count,COUNT (1) tc	FROM paper_author WHERE paper_id IN (	SELECT DISTINCT "
				+ "paper_id FROM paper_author WHERE professor_id = ? ) AND professor_id <>?  AND professor_id <> '################################' GROUP BY professor_id ) "
				+ ") _T_ GROUP BY professor_id ORDER BY tc DESC LIMIT ?");
		try {
			ps.setString(1, id);
			ps.setString(2, id);
			ps.setString(3, id);
			ps.setString(4, id);
			ps.setInt(5, rows);
			ResultSet rs = ps.executeQuery();
			try {
				List<Map<String, Object>> ret = new ArrayList<Map<String, Object>>();
				while (rs.next()) {
					Map<String, Object> row = new HashMap<String, Object>();
					ret.add(row);
					row.put("professorId", rs.getString(1));
					row.put("patentCount", rs.getInt(2));
					row.put("paperCount", rs.getInt(3));
				}
				return ret;
			} finally {
				JdbcUtil.close(rs);
			}
		} finally {
			JdbcUtil.close(ps);
		}
	}
	
	
	@Get
	@Path("/coadjutantByPatent")
	public List<Map<String, Object>> queryCoadjutantByPatent(@JdbcConn Connection con, String id, @DefaultValue("5") int rows) throws SQLException {
		PreparedStatement ps = con.prepareStatement("SELECT professor_id,COUNT (1) tc FROM patent_author "+
				"WHERE patent_id IN ( SELECT DISTINCT patent_id FROM patent_author WHERE professor_id =? ) "+
				"AND professor_id <>? AND professor_id <> '################################' GROUP BY professor_id order by tc desc limit ?");
		try {
			ps.setString(1, id);
			ps.setString(2, id);
			ps.setInt(3, rows);
			ResultSet rs = ps.executeQuery();
			try {
				List<Map<String, Object>> ret = new ArrayList<Map<String, Object>>();
				while (rs.next()) {
					Map<String, Object> row = new HashMap<String, Object>();
					ret.add(row);
					row.put("professorId", rs.getString(1));
					row.put("count", rs.getInt(2));
				}
				return ret;
			} finally {
				JdbcUtil.close(rs);
			}
		} finally {
			JdbcUtil.close(ps);
		}
	}

	@Get
	@Path("/qm")
	public List<EditProfessor> query(@JdbcConn Connection con,String[] id)throws SQLException {
		List<EditProfessor> editProfessors= this.professorDao.queryPro(con, id);
		if (!editProfessors.isEmpty()) {
			for (EditProfessor editProfessor : editProfessors) {
				editProfessor.setHasHeadImage(this.imageService.hasProfessorImage(editProfessor.getId()));
				if(editProfessor.getOrgId() != null) {
					Organization organization = this.orgDao.query(con, editProfessor.getOrgId());
					if(organization != null) {
						editProfessor.setOrgName(organization.getName());
					}
				}
			}
		}
		return hiddenPrivacyInfo(editProfessors);
	}

	public static <T extends Professor> T hiddenPrivacyInfo(T p) {
		if (null != p) {
			p.setPhone(null);
			p.setEmail(null);
		}
		return p;
	}

	public static <T extends Professor> List<T> hiddenPrivacyInfo(List<T> ps) {
		if (ps != null && ps.size() > 0)
			for (Professor p : ps) {
				hiddenPrivacyInfo(p);
			}
		return ps;
	}

	//
	//
	// @Get
	// @Path("/articleRef")

	public static void main(String[] args) throws Exception {
		// Connection con =
		// DriverManager.getConnection("jdbc:postgresql://121.42.53.174:5432/ekexiu",
		// "postgres", "postgres");
		// try{
		// ProfessorService service = new ProfessorService();
		// ProfessorDao dao = new ProfessorDaoExtend();
		// service.setProfessorDao(dao);
		// PageQueryResult<Professor> result =service.query(con,"鏉?, "鏉愭枡",
		// "閲戝睘", 10, 2);
		// System.out.println(result.getTotal());
		// for(Professor p:result.getData()){
		// System.out.println("======");
		// JsonService.toJson(p,System.out);
		// }
		// }finally{
		// con.close();
		// }
		System.out.println(URLEncoder.encode("输出中文", "UTF-8"));
	}
}
