package com.ekexiu.portal.team;

import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/7/10.
 */
@DAO
public interface TeamKeyWordDao {

    @Insert
    @Batch
    int[] insert(Connection con, TeamKeyWord[] pkw)throws SQLException;

    @DeleteWith
    @From(TeamKeyWord.class)
    int delete(Connection con,String id)throws SQLException;
}
