package com.ekexiu.portal.views;


import com.ekexiu.portal.views.service.Main;
import org.jfw.util.context.JfwAppContext;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;

public class LogImageServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	private static byte[] png = new byte[] { -119, 80, 78, 71, 13, 10, 26, 10, 0, 0, 0, 13, 73, 72, 68, 82, 0, 0, 0, 1, 0, 0, 0, 1, 8, 2, 0, 0, 0, -112, 119,
			83, -34, 0, 0, 0, 1, 115, 82, 71, 66, 0, -82, -50, 28, -23, 0, 0, 0, 4, 103, 65, 77, 65, 0, 0, -79, -113, 11, -4, 97, 5, 0, 0, 0, 9, 112, 72, 89,
			115, 0, 0, 14, -61, 0, 0, 14, -61, 1, -57, 111, -88, 100, 0, 0, 0, 12, 73, 68, 65, 84, 24, 87, 99, -8, -1, -1, 63, 0, 5, -2, 2, -2, -89, 53, -127,
			-124, 0, 0, 0, 0, 73, 69, 78, 68, -82, 66, 96, -126 };
	private static int png_size = png.length;

	private Main main;

	@Override
	public void init() throws ServletException {
		main = (Main) JfwAppContext.getBeanFactory().getBean("com_ekexiu_portal_views_service_Main");
	}

	protected void doGet(HttpServletRequest request, HttpServletResponse res) throws ServletException, IOException {
		main.log(request.getParameterMap());
		res.setDateHeader("Expires", 0);
		res.setHeader("Cache-Control", "no-store, no-cache, must-revalidate");
		res.addHeader("Cache-Control", "post-check=0, pre-check=0");
		res.setHeader("Pragma", "no-cache");
		res.setContentType("image/png");
		res.setContentLength(png_size);
		OutputStream out = res.getOutputStream();
		try {
			out.write(png);
		} finally {
			try {
				out.close();
			} catch (Exception e) {
			}
		}

	}
}
