package com.ekexiu.portal.views.handler;


import com.ekexiu.portal.views.pojo.LogEntry;

import java.util.Map;
import java.util.concurrent.ConcurrentLinkedQueue;


public abstract class LogHandler  implements Runnable{


	private long initialDelay;
	private long period;
	
	
	

	
	public long getInitialDelay() {
		return initialDelay;
	}

	public void setInitialDelay(long initialDelay) {
		this.initialDelay = initialDelay;
	}

	public long getPeriod() {
		return period;
	}

	public void setPeriod(long period) {
		this.period = period;
	}

	protected ConcurrentLinkedQueue<LogEntry> queue = new ConcurrentLinkedQueue<LogEntry>();
	
	public void add(Map<String,String[]> map){
		if(this.match(map.get("__lt"))){
			queue.offer(LogEntry.build(map));
		}
	}
	
	public abstract boolean match(String[] logType);

	

	
}
