package com.ekexiu.portal.views.pojo;

import com.ekexiu.portal.po.Ppatent;
import org.jfw.apt.orm.annotation.entry.CalcColumn;
import org.jfw.apt.orm.annotation.entry.ExtendView;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

/**
 * Created by TT on 2019/3/14.
 */
@ExtendView(fromSentence = "ppatent c LEFT JOIN ppatent_day_sum cds on c.id = cds.id", tableAlias = "c")
public class PpatentSum extends Ppatent {
    private int sum;
    private String platform;

    @CalcColumn(handlerClass = StringHandler.class, column = "cds.platform")
    public String getPlatform() {
        return platform;
    }

    public void setPlatform(String platform) {
        this.platform = platform;
    }


    @CalcColumn(handlerClass = IntHandler.class, column = "COALESCE(cds.sum,0) as sum")
    public int getSum() {
        return sum;
    }

    public void setSum(int sum) {
        this.sum = sum;
    }
}
