package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;

import com.ekexiu.portal.po.PaperAuthor;

@DAO
public interface PaperAuthorDao {
	
	@SelectList
	List<PaperAuthor> query(Connection con,String paperId) throws SQLException;
	
	@UpdateWith
	@From(PaperAuthor.class)
	@SetSentence("ASS_TIME=TO_CHAR(NOW(),'YYYYMMDDHH24MISS')")
	@Where("PROFESSOR_ID='################################'")
	int update(Connection con,String paperId,@Set String professorId,String name)throws SQLException;
	
	@UpdateWith
	@From(PaperAuthor.class)
	@SetSentence("PROFESSOR_ID='################################'")
	int update(Connection con,String paperId,String professorId)throws SQLException;
	
	
	
	@UpdateWith
	@From(PaperAuthor.class)
	@SetSentence("PROFESSOR_ID='################################'")
	int cAss(Connection con,String professorId)throws SQLException;
}
