package com.ekexiu.portal.platform;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.CreateTimeSupported;
/**
 * 对接的专家
 * 
 * @author Saga
 *
 */
@PrimaryKey({"pid","uid"})
@Table
public class ButtedProfessor implements CreateTimeSupported {
	/**
	 * 平台ID
	 */
	private String pid;
	/**
	 * 对接的专家ID
	 */
	private String uid;
	private String createTime;
	
	@Column(DE.text_de)
	public String getPid() {
		return pid;
	}
	public void setPid(String pid) {
		this.pid = pid;
	}
	@Column(DE.text_de)
	public String getUid() {
		return uid;
	}
	public void setUid(String uid) {
		this.uid = uid;
	}
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	
}
