package com.ekexiu.portal.platform;

import org.jfw.apt.orm.annotation.entry.CalcColumn;
import org.jfw.apt.orm.annotation.entry.View;
import org.jfw.apt.orm.core.defaultImpl.LongHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

@View("(SELECT P.ID OID,'1' OTYPE, R.RESOURCE_ID RID,R.RESOURCE_NAME RNAME, R.SUBJECT KEYWORDS,R.SUPPORTED_SERVICES CNT,I.IMAGE_SRC IMAGES,P.NAME FNAME,'' SNAME,B.PID PID,R.PUBLISH_TIME PTIME,R.SHARE_ID SHARE_ID,R.COMP COMP "+
	    "FROM RESOURCE R INNER JOIN PROFESSOR P ON R.PROFESSOR_ID=P.ID  INNER JOIN BUTTED_PROFESSOR B ON P.ID = B.UID  LEFT JOIN IMAGE I ON R.RESOURCE_ID=I.RESOURCE_ID "+
	    "WHERE R.STATUS='1' AND R.RESOURCE_TYPE='1' "+
	    "UNION ALL "+
	    "SELECT  O.ID OID,'2' OTYPE,R.RESOURCE_ID RID,R.RESOURCE_NAME RNAME, R.SUBJECT KEYWORDS,R.SUPPORTED_SERVICES CNT,I.IMAGE_SRC IMAGES,O.NAME FNAME,O.FOR_SHORT SNAME,B.PID PID,R.PUBLISH_TIME PTIME,R.SHARE_ID SHARE_ID,R.COMP COMP "+ 
	    "FROM RESOURCE R INNER JOIN ORGANIZATION O ON R.ORG_ID=O.ID  INNER JOIN BUTTED_ORG B ON O.ID = B.OID  LEFT JOIN IMAGE I ON R.RESOURCE_ID=I.RESOURCE_ID "+
	    "WHERE R.STATUS='1' AND R.RESOURCE_TYPE='2' ) T ")
public class PlatformResource {
	private String id;
	private String name;
//	private String keywords;
	private String cnt;
	private String images;
//	private String fname;
//	private String sname;
	private String pid;
	private String time;
	private long shareId;
	private String oid;
	private String otype;
	
	@CalcColumn(column="OID",handlerClass=StringHandler.class,nullable = false)
	public String getOid() {
		return oid;
	}
	public void setOid(String oid) {
		this.oid = oid;
	}
	@CalcColumn(column="OTYPE",handlerClass=StringHandler.class,nullable = false)
	public String getOtype() {
		return otype;
	}
	public void setOtype(String otype) {
		this.otype = otype;
	}
	@CalcColumn(column="RID",handlerClass=StringHandler.class,nullable = false)
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	@CalcColumn(column="RNAME",handlerClass=StringHandler.class,nullable = false)
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
//	@CalcColumn(column="KEYWORDS",handlerClass=StringHandler.class,nullable = true)
//	public String getKeywords() {
//		return keywords;
//	}
//	public void setKeywords(String keywords) {
//		this.keywords = keywords;
//	}
	@CalcColumn(column="CNT",handlerClass=StringHandler.class,nullable = true)
	public String getCnt() {
		return cnt;
	}
	public void setCnt(String cnt) {
		this.cnt = cnt;
	}
	@CalcColumn(column="IMAGES",handlerClass=StringHandler.class,nullable = true)
	public String getImages() {
		return images;
	}
	public void setImages(String images) {
		this.images = images;
	}
//	@CalcColumn(column="FNAME",handlerClass=StringHandler.class,nullable = false)
//	public String getFname() {
//		return fname;
//	}
//	public void setFname(String fname) {
//		this.fname = fname;
//	}
//	@CalcColumn(column="SNAME",handlerClass=StringHandler.class,nullable = true)
//	public String getSname() {
//		return sname;
//	}
//	public void setSname(String sname) {
//		this.sname = sname;
//	}
	@CalcColumn(column="PID",handlerClass=StringHandler.class,nullable = false)
	public String getPid() {
		return pid;
	}
	public void setPid(String pid) {
		this.pid = pid;
	}
	@CalcColumn(column="PTIME",handlerClass=StringHandler.class,nullable = false)
	public String getTime() {
		return time;
	}
	public void setTime(String time) {
		this.time = time;
	}
	@CalcColumn(column="SHARE_ID",handlerClass=LongHandler.class,nullable = false)
	public long getShareId() {
		return shareId;
	}
	public void setShareId(long shareId) {
		this.shareId = shareId;
	}
}
