package com.ekexiu.portal.po;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.annotation.entry.Unique;
import org.jfw.apt.orm.annotation.entry.Uniques;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.CreateTimeSupported;

@Table
@Uniques(@Unique(clolumns = { "resourceId", "resourceTmpId" }, name = "RESOURCE_TMP_LOG_UQ"))
public class ResourceTmpLog implements CreateTimeSupported {
	private String ownerId;
	private String resourceId;
	private String resourceTmpId;
	private String createTime;

	@Column(DE.id_32)
	public String getOwnerId() {
		return ownerId;
	}

	public void setOwnerId(String ownerId) {
		this.ownerId = ownerId;
	}

	@Column(DE.id_32)
	public String getResourceId() {
		return resourceId;
	}

	public void setResourceId(String resourceId) {
		this.resourceId = resourceId;
	}

	@Column(DE.id_32)
	public String getResourceTmpId() {
		return resourceTmpId;
	}

	public void setResourceTmpId(String resourceTmpId) {
		this.resourceTmpId = resourceTmpId;
	}

	public String getCreateTime() {
		return createTime;
	}

	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}

}
