package com.ekexiu.portal.resResult;

import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/07/10.
 */
@DAO
public interface ResResultKeyWordDao {
    @Insert
    @Batch
    int[] insert(Connection con, ResResultKeyWord[] rrkws) throws SQLException;

    @DeleteWith
    @From(ResResultKeyWord.class)
    int delete(Connection con, String id) throws SQLException;
}